/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: GERA_NOTAFISCAL_VENDA

DESCRIO:
   Procedimento para gerao de notas fiscais a partir das vendas. Esta procedure  chamada da tela de
emisso de notas fiscais - DFS15000

CRIAO:
   16/12/2003 - Roberto A. Lopes Martins

@c:\web_565\sql\end_conv\oracle\5502_DFSSTPO_Gera_NotaFiscal_VendaMSDE.SQL
RAISE_APPLICATION_ERROR(-20501,, TRUE);
*/

CREATE OR REPLACE PROCEDURE GERA_NOTAFISCAL_VENDAMSDE
   (P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
    P_CDLOJA        IN VENDA.CDLOJA%TYPE,
    P_CDCAIXA       IN VARCHAR2,
    P_LISTAVENDA    IN VARCHAR2,
    P_DTINICIAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_DTFINAL       IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_CDCLIENTE     IN NOTAFISCAL.CDCLIENTE%TYPE,
    P_NMFANTCLIE    IN CLIENTE.NMFANTCLIE%TYPE,
    P_DTSAIDA       IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_CDSERIE       IN NOTAFISCAL.CDSERIE%TYPE,
    P_CDTIPOOPER    IN NOTAFISCAL.CDTIPOOPER%TYPE,
    P_CDFILIPROC    IN NOTAFISCAL.CDFILIAL%TYPE,
    P_CDOPERADOR    IN VARCHAR2,
    P_DSMENSAGEM    IN VARCHAR2,
    P_IDTPIJUDESNF  IN DADOSNF.IDTPIJUDESNF%TYPE DEFAULT NULL,
    P_NRINSJUDESNF  IN DADOSNF.NRINSJUDESNF%TYPE DEFAULT NULL,
    P_NMRAZSODESNF  IN DADOSNF.NMRAZSODESNF%TYPE DEFAULT NULL,
    P_DSENDEDESTNF  IN DADOSNF.DSENDEDESTNF%TYPE DEFAULT NULL,
    P_NMBAIRDESTNF  IN DADOSNF.NMBAIRDESTNF%TYPE DEFAULT NULL,
    P_CDPAIS        IN DADOSNF.CDPAIS%TYPE DEFAULT NULL,
    P_SGESTADO      IN DADOSNF.SGESTADO%TYPE DEFAULT NULL,
    P_CDMUNICIPIO   IN DADOSNF.CDMUNICIPIO%TYPE DEFAULT NULL,
    P_NRINSESTDESNF IN DADOSNF.NRINSESTDESNF%TYPE DEFAULT NULL)

AS

   V_CDCONTADOR   NUMBER;
   V_DADOSNF      NUMBER;
   V_CDPAIS       ENDEFILI.CDPAIS%TYPE;
   V_SGESTADO     ENDEFILI.SGESTADO%TYPE;
   V_CDMUNICIPIO  ENDEFILI.CDMUNICIPIO%TYPE;

   V_CDEMPRESA    FILIAL.CDEMPRESA%TYPE;
   V_CDINSCESTA   FILIAL.CDINSCESTA%TYPE;
   V_NRMAXITNF    SERIENF.NRMAXITNF%TYPE;
   V_IDCONMAXITEM SERIENF.IDCONMAXITEM%TYPE;

   V_NRLANCTONF   NOTAFISCAL.NRLANCTONF%TYPE;
   V_NRLANCESTQ   LANCTOESTOQ.NRLANCESTQ%TYPE;

   V_IDTIPORECE   TIPORECE.IDTIPORECE%TYPE;

   V_CDALMOXARIFE ITEMPRODUTO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQ ITEMPRODUTO.CDLOCALESTOQ%TYPE;

   V_DTSAIDA      NOTAFISCAL.DTENTRSAID%TYPE;
   V_NRCUPOMFIS   VENDA.NRCUPOMFIS%TYPE;

   V_NRACESSONFCE VENDA.NRACESSONFCE%TYPE;

   V_NRSEQCUPOMNF DADOSNF.NRSEQCUPOMNF%TYPE;

   V_NRMD5ARQTXT TURCAIXA.NRMD5ARQTXT%TYPE;


   CURSOR C_ITEMVENDA IS
      SELECT V.CDFILIALIMP AS CDFILIAL, V.NRSEQVENIMP AS NRSEQVENDA, V.CDCAIXAIMP AS CDCAIXA, V.CDLOJAIMP AS CDLOJA,
             V.DTENTRVENIMP AS DTENTRVENDA, P.CDPRODUTO, P.NMPRODUTO,
             P.CDARVPROD, P.CDPRODESTO, V.NRMD5ARQTXTIMP, V.NRCUPFISIMP AS NRCUPOMFIS, V.NRECFCUPOMIMP,
             V.NRSERIEIMPIMP, V.DSMODELOECFIMP,V.DSMARCAECFIMP, V.NRACESSONFCEIMP AS NRACESSONFCE ,
             (V.VRUNITVENIMP + NVL(V.VRUNITVECIMP,0)) AS VRUNITVEND,
             SUM(V.QTPRODVENIMP) AS QTPRODVEND,
             NVL(SUM(V.VRDESITVEIMP),0) AS VRDESITVEND,
             SUM((V.QTPRODVENIMP * (V.VRUNITVENIMP + NVL(V.VRUNITVECIMP,0))) - NVL(V.VRDESITVEIMP,0)) AS VRTOTAITEM
      FROM VENDAAUX V, PRODUTO P
      WHERE (V.CDFILIALIMP     = P_CDFILIAL)       AND
            (V.CDLOJAIMP       = P_CDLOJA)         AND
            (V.CDPRODIMP    = P.CDPRODUTO)      AND
            (V.DTENTRVENIMP BETWEEN P_DTINICIAL  AND P_DTFINAL) AND
            ((INSTR(P_CDCAIXA, V.CDCAIXAIMP) > 0)  OR (P_CDCAIXA IS NULL)) AND
            ((P_LISTAVENDA IS NULL) OR (INSTR(P_LISTAVENDA, V.CDFILIALIMP||V.CDCAIXAIMP||V.NRSEQVENIMP) > 0))
      GROUP BY V.CDFILIALIMP, V.NRSEQVENIMP, V.CDCAIXAIMP, V.CDLOJAIMP, V.DTENTRVENIMP, P.CDPRODUTO, P.NMPRODUTO,
               P.CDARVPROD, P.CDPRODESTO, V.NRMD5ARQTXTIMP, V.NRCUPFISIMP, V.NRECFCUPOMIMP, V.NRSERIEIMPIMP, V.DSMODELOECFIMP,
               V.DSMARCAECFIMP, V.NRACESSONFCEIMP, (V.VRUNITVENIMP + NVL(V.VRUNITVECIMP,0))
      ORDER BY V.CDFILIALIMP, V.CDLOJAIMP, NVL(V.NRCUPFISIMP, V.NRACESSONFCEIMP);

BEGIN
   /*Inserir Cliente*/
   SELECT COUNT(*)
   INTO V_CDCONTADOR
   FROM CLIENTE
   WHERE CDCLIENTE = P_CDCLIENTE;

   IF V_CDCONTADOR = 0 THEN
      INSERT INTO CLIENTE
         (CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE)
      VALUES
         (P_CDCLIENTE, SUBSTR(P_CDCLIENTE,1,1), SUBSTR(P_CDCLIENTE,2,20), P_NMFANTCLIE, P_NMFANTCLIE);

      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
      INTO V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO
      FROM ENDEFILI
      WHERE CDFILIAL     = P_CDFILIAL AND
            IDTPENDEFILI = 'P';

      INSERT INTO ENDECLIE
         (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO)
      VALUES
         (P_CDCLIENTE, 'P', V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO);
   END IF;

   /*Gerao das Notas Fiscais*/
   SELECT MAX(CDEMPRESA), MAX(CDINSCESTA)
   INTO V_CDEMPRESA, V_CDINSCESTA
   FROM FILIAL
   WHERE CDFILIAL = P_CDFILIAL;

   SELECT NVL(MAX(NRMAXITNF),10), NVL(MAX(IDCONMAXITEM),'S')
   INTO V_NRMAXITNF, V_IDCONMAXITEM
   FROM SERIENF
   WHERE CDEMPRESA  = V_CDEMPRESA  AND
         CDINSCESTA = V_CDINSCESTA AND
         CDSERIE    = P_CDSERIE;

   V_CDCONTADOR := 0;
   V_NRCUPOMFIS := 'X';
   V_NRACESSONFCE := 'X';

   FOR C_GERANF IN C_ITEMVENDA LOOP

      SELECT NRMD5ARQTXT
        INTO V_NRMD5ARQTXT
        FROM (SELECT NRMD5ARQTXT
                FROM TURCAIXA
               WHERE CDFILIAL = P_CDFILIAL
                 AND CDCAIXA = C_GERANF.CDCAIXA
                 AND NRMD5ARQTXT IS NOT NULL
               ORDER BY DTABERCAIX DESC)
       WHERE ROWNUM = 1;

      IF V_CDCONTADOR = 0 THEN
         V_CDCONTADOR := 1;

         IF P_DTSAIDA IS NULL THEN
            V_DTSAIDA := C_GERANF.DTENTRVENDA;
         ELSE
            V_DTSAIDA := P_DTSAIDA;
         END IF;

         GERA_NOTAFISCAL_CORPO (P_CDFILIPROC, P_CDFILIAL, V_CDEMPRESA,
                                P_CDTIPOOPER, P_CDSERIE, P_CDCLIENTE,
                                V_DTSAIDA, 'PDV', V_NRLANCTONF,
                                V_NRLANCESTQ, 'S');

      END IF;

      IF (V_CDCONTADOR > V_NRMAXITNF) AND (V_IDCONMAXITEM = 'S') THEN
         V_CDCONTADOR := 1;

         /*Atualizao de Estoque*/
         GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF, SYSDATE,
                                    V_NRLANCESTQ, 'S');
         UPDATE NOTAFISCAL
         SET    CDOPERGERA = P_CDOPERADOR
         WHERE (CDFILIAL   = P_CDFILIPROC) AND
               (NRLANCTONF = V_NRLANCTONF);

         ATUALIZA_IDEVOLESTOQ(P_CDFILIPROC, V_NRLANCESTQ);

         ATUALIZA_DADOSADIC(P_CDFILIAL, P_CDCAIXA, P_CDFILIPROC, V_NRLANCTONF, V_NRMD5ARQTXT, P_DSMENSAGEM);

         IF P_DTSAIDA IS NULL THEN
            V_DTSAIDA := C_GERANF.DTENTRVENDA;
         ELSE
            V_DTSAIDA := P_DTSAIDA;
         END IF;

         GERA_NOTAFISCAL_CORPO (P_CDFILIPROC, P_CDFILIAL, V_CDEMPRESA,
                                P_CDTIPOOPER, P_CDSERIE, P_CDCLIENTE,
                                V_DTSAIDA, 'PDV', V_NRLANCTONF,
                                V_NRLANCESTQ, 'S');

      END IF;

      SELECT MAX(CDALMOXARIFE), MAX(CDLOCALESTOQ)
      INTO V_CDALMOXARIFE, V_CDLOCALESTOQ
      FROM LOJA
      WHERE CDFILIAL = P_CDFILIAL AND
            CDLOJA   = C_GERANF.CDLOJA;

      GERA_NOTAFISCAL_PRODUTO(P_CDFILIPROC, V_NRLANCTONF, C_GERANF.CDPRODUTO,
                              C_GERANF.CDARVPROD, C_GERANF.NMPRODUTO,
                              C_GERANF.QTPRODVEND, C_GERANF.VRUNITVEND, C_GERANF.VRDESITVEND,
                              NULL, NULL, NULL, NULL, NULL, NULL, V_CDALMOXARIFE, V_CDLOCALESTOQ);

      /*Atualiza os dados do cliente da nota fiscal*/
      IF (C_GERANF.NRACESSONFCE IS NULL) THEN
         SELECT COUNT(*)
           INTO V_DADOSNF
           FROM DADOSNF
          WHERE (CDFILIAL   = P_CDFILIPROC)
            AND (NRLANCTONF = V_NRLANCTONF)
            AND (NRCOOCUPOMNF = C_GERANF.NRCUPOMFIS);
      ELSE
         SELECT COUNT(*)
           INTO V_DADOSNF
           FROM DADOSNF
          WHERE (CDFILIAL   = P_CDFILIPROC)
            AND (NRLANCTONF = V_NRLANCTONF)
            AND (NRACESSONFCENF = C_GERANF.NRACESSONFCE);   
      END IF;

      IF V_DADOSNF = 0 THEN
         SELECT MAX(NRSEQCUPOMNF)
           INTO V_NRSEQCUPOMNF
           FROM DADOSNF
          WHERE (CDFILIAL   = P_CDFILIPROC)
            AND (NRLANCTONF = V_NRLANCTONF);

         V_NRSEQCUPOMNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(NVL(V_NRSEQCUPOMNF, '0')) + 1)), 3, 0);
         
         INSERT INTO DADOSNF
           (CDFILIAL, NRLANCTONF, IDTPIJUDESNF, NRINSJUDESNF, NMRAZSODESNF,
            DSENDEDESTNF, NMBAIRDESTNF, CDPAIS, SGESTADO, CDMUNICIPIO,
            NRMD5ARQTXTNF, NRCOOCUPOMNF, NRECFCUPOMNF, NRSERIEIMPNF, DSMODELOECFNF,
            DSMARCAECFNF, NRINSESTDESNF, NRACESSONFCENF, NRSEQCUPOMNF)
         VALUES
            (P_CDFILIPROC, V_NRLANCTONF, P_IDTPIJUDESNF, P_NRINSJUDESNF, P_NMRAZSODESNF,
             P_DSENDEDESTNF, P_NMBAIRDESTNF, P_CDPAIS, P_SGESTADO, P_CDMUNICIPIO,
             C_GERANF.NRMD5ARQTXTIMP, C_GERANF.NRCUPOMFIS, C_GERANF.NRECFCUPOMIMP, C_GERANF.NRSERIEIMPIMP,
             C_GERANF.DSMODELOECFIMP, C_GERANF.DSMARCAECFIMP, P_NRINSESTDESNF, C_GERANF.NRACESSONFCE,
             V_NRSEQCUPOMNF);
      END IF;

      V_CDCONTADOR := V_CDCONTADOR + 1;
   END LOOP;

   IF (V_CDCONTADOR > 0) THEN
      V_CDCONTADOR := 1;

      /*Atualizao de Estoque*/
      GERA_NOTAFISCAL_FECHAMENTO(P_CDFILIPROC, V_NRLANCTONF, SYSDATE,
                                 V_NRLANCESTQ, 'S');

      UPDATE NOTAFISCAL
      SET    CDOPERGERA = P_CDOPERADOR
      WHERE (CDFILIAL   = P_CDFILIPROC) AND
            (NRLANCTONF = V_NRLANCTONF);

      ATUALIZA_IDEVOLESTOQ(P_CDFILIPROC, V_NRLANCESTQ);

      ATUALIZA_DADOSADIC(P_CDFILIAL, P_CDCAIXA, P_CDFILIPROC, V_NRLANCTONF, V_NRMD5ARQTXT, P_DSMENSAGEM);
   END IF;

   SELECT COUNT(*)
   INTO V_CDCONTADOR
   FROM SERIEENTR
   WHERE CDSERIEENTR = P_CDSERIE;

   IF V_CDCONTADOR = 0 THEN
      INSERT INTO SERIEENTR
         (CDSERIEENTR, DSSERIEENTR)
      VALUES
         (P_CDSERIE, P_CDSERIE);
   END IF;

   V_CDCONTADOR := 0;
   V_NRCUPOMFIS := 'X';
   V_NRACESSONFCE := 'X';
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_NOTAFISCAL_VENDAMSDE','6.10.XXX'); END;
/


